diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/regular-wifi-mac.h ns-3.34/src/wifi/model/regular-wifi-mac.h
--- ns-3.33/src/wifi/model/regular-wifi-mac.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/regular-wifi-mac.h	2021-07-14 10:31:07.000000000 -0700
@@ -24,14 +24,20 @@
 #include "wifi-mac.h"
 #include "qos-txop.h"
 #include "ssid.h"
+#include <set>
+#include <unordered_map>
 
 namespace ns3 {
 
-class MacLow;
 class MacRxMiddle;
 class MacTxMiddle;
 class ChannelAccessManager;
 class ExtendedCapabilities;
+class FrameExchangeManager;
+class WifiPsdu;
+enum WifiTxTimerReason : uint8_t;
+
+typedef std::unordered_map <uint16_t /* staId */, Ptr<WifiPsdu> /* PSDU */> WifiPsduMap;
 
 /**
  * \brief base class for all MAC-level wifi objects.
@@ -54,38 +60,36 @@
   virtual ~RegularWifiMac ();
 
   // Implementations of pure virtual methods.
-  void SetShortSlotTimeSupported (bool enable);
-  void SetSsid (Ssid ssid);
-  void SetAddress (Mac48Address address);
-  void SetPromisc (void);
-  bool GetShortSlotTimeSupported (void) const;
-  Ssid GetSsid (void) const;
-  Mac48Address GetAddress (void) const;
-  Mac48Address GetBssid (void) const;
-  virtual void Enqueue (Ptr<Packet> packet, Mac48Address to, Mac48Address from);
-  virtual bool SupportsSendFrom (void) const;
-  virtual void SetWifiPhy (const Ptr<WifiPhy> phy);
-  Ptr<WifiPhy> GetWifiPhy (void) const;
-  void ResetWifiPhy (void);
-  virtual void SetWifiRemoteStationManager (const Ptr<WifiRemoteStationManager> stationManager);
-  void ConfigureStandard (WifiStandard standard);
-
-  /**
-   * This type defines the callback of a higher layer that a
-   * WifiMac(-derived) object invokes to pass a packet up the stack.
-   *
-   * \param packet the packet that has been received.
-   * \param from the MAC address of the device that sent the packet.
-   * \param to the MAC address of the device that the packet is destined for.
-   */
-  typedef Callback<void, Ptr<const Packet>, Mac48Address, Mac48Address> ForwardUpCallback;
-
-  void SetForwardUpCallback (ForwardUpCallback upCallback);
-  void SetLinkUpCallback (Callback<void> linkUp);
-  void SetLinkDownCallback (Callback<void> linkDown);
+  void SetShortSlotTimeSupported (bool enable) override;
+  void SetSsid (Ssid ssid) override;
+  void SetAddress (Mac48Address address) override;
+  void SetPromisc (void) override;
+  bool GetShortSlotTimeSupported (void) const override;
+  Ssid GetSsid (void) const override;
+  Mac48Address GetAddress (void) const override;
+  Mac48Address GetBssid (void) const override;
+  void Enqueue (Ptr<Packet> packet, Mac48Address to, Mac48Address from) override;
+  bool SupportsSendFrom (void) const override;
+  void SetWifiPhy (const Ptr<WifiPhy> phy) override;
+  Ptr<WifiPhy> GetWifiPhy (void) const override;
+  void ResetWifiPhy (void) override;
+  void SetWifiRemoteStationManager (const Ptr<WifiRemoteStationManager> stationManager) override;
+  void ConfigureStandard (WifiStandard standard) override;
+  TypeOfStation GetTypeOfStation (void) const override;
+  void SetForwardUpCallback (ForwardUpCallback upCallback) override;
+  void SetLinkUpCallback (Callback<void> linkUp) override;
+  void SetLinkDownCallback (Callback<void> linkDown) override;
+  Ptr<WifiRemoteStationManager> GetWifiRemoteStationManager (void) const override;
 
   // Should be implemented by child classes
-  virtual void Enqueue (Ptr<Packet> packet, Mac48Address to) = 0;
+  void Enqueue (Ptr<Packet> packet, Mac48Address to) override = 0;
+
+  /**
+   * Get the Frame Exchange Manager
+   *
+   * \return the Frame Exchange Manager
+   */
+  Ptr<FrameExchangeManager> GetFrameExchangeManager (void) const;
 
   /**
    * Enable or disable CTS-to-self feature.
@@ -100,9 +104,26 @@
   void SetBssid (Mac48Address bssid);
 
   /**
-   * \return the station manager attached to this MAC.
+   * Accessor for the DCF object
+   *
+   * \return a smart pointer to Txop
    */
-  Ptr<WifiRemoteStationManager> GetWifiRemoteStationManager (void) const;
+  Ptr<Txop> GetTxop (void) const;
+  /**
+   * Accessor for a specified EDCA object
+   *
+   * \param ac the Access Category
+   * \return a smart pointer to a QosTxop
+   */
+  Ptr<QosTxop> GetQosTxop (AcIndex ac) const;
+  /**
+   * Accessor for a specified EDCA object
+   *
+   * \param tid the Traffic ID
+   * \return a smart pointer to a QosTxop
+   */
+  Ptr<QosTxop> GetQosTxop (uint8_t tid) const;
+
   /**
    * Return the extended capabilities of the device.
    *
@@ -129,14 +150,15 @@
   HeCapabilities GetHeCapabilities (void) const;
 
 protected:
-  virtual void DoInitialize ();
-  virtual void DoDispose ();
+  void DoInitialize () override;
+  void DoDispose () override;
+  void SetTypeOfStation (TypeOfStation type) override;
 
-  Ptr<MacRxMiddle> m_rxMiddle;  //!< RX middle (defragmentation etc.)
-  Ptr<MacTxMiddle> m_txMiddle;  //!< TX middle (aggregation etc.)
-  Ptr<MacLow> m_low;            //!< MacLow (RTS, CTS, Data, Ack etc.)
+  Ptr<MacRxMiddle> m_rxMiddle;                      //!< RX middle (defragmentation etc.)
+  Ptr<MacTxMiddle> m_txMiddle;                      //!< TX middle (aggregation etc.)
   Ptr<ChannelAccessManager> m_channelAccessManager; //!< channel access manager
-  Ptr<WifiPhy> m_phy;           //!< Wifi PHY
+  Ptr<WifiPhy> m_phy;                               //!< Wifi PHY
+  Ptr<FrameExchangeManager> m_feManager;            //!< Frame Exchange Manager
 
   Ptr<WifiRemoteStationManager> m_stationManager; //!< Remote station manager (rate control, RTS/CTS/fragmentation thresholds etc.)
 
@@ -159,13 +181,6 @@
   EdcaQueues m_edca;
 
   /**
-   * Accessor for the DCF object
-   *
-   * \return a smart pointer to Txop
-   */
-  Ptr<Txop> GetTxop (void) const;
-
-  /**
    * Accessor for the AC_VO channel access function
    *
    * \return a smart pointer to QosTxop
@@ -200,16 +215,6 @@
   void ConfigureContentionWindow (uint32_t cwMin, uint32_t cwMax);
 
   /**
-   * This method is invoked by a subclass to specify what type of
-   * station it is implementing. This is something that the channel
-   * access functions (instantiated within this class as QosTxop's)
-   * need to know.
-   *
-   * \param type the type of station.
-   */
-  void SetTypeOfStation (TypeOfStation type);
-
-  /**
    * This method acts as the MacRxMiddle receive callback and is
    * invoked to notify us that a frame has been received. The
    * implementation is intended to capture logic that is going to be
@@ -223,20 +228,6 @@
    * \param mpdu the MPDU that has been received.
    */
   virtual void Receive (Ptr<WifiMacQueueItem> mpdu);
-  /**
-   * The packet we sent was successfully received by the receiver
-   * (i.e. we received an Ack from the receiver).
-   *
-   * \param hdr the header of the packet that we successfully sent
-   */
-  virtual void TxOk (const WifiMacHeader &hdr);
-  /**
-   * The packet we sent was successfully received by the receiver
-   * (i.e. we did not receive an Ack from the receiver).
-   *
-   * \param hdr the header of the packet that we failed to sent
-   */
-  virtual void TxFailed (const WifiMacHeader &hdr);
 
   /**
    * Forward the packet up to the device.
@@ -256,16 +247,6 @@
   virtual void DeaggregateAmsduAndForward (Ptr<WifiMacQueueItem> mpdu);
 
   /**
-   * This method can be called to accept a received ADDBA Request. An
-   * ADDBA Response will be constructed and queued for transmission.
-   *
-   * \param reqHdr a pointer to the received ADDBA Request header.
-   * \param originator the MAC address of the originator.
-   */
-  void SendAddBaResponse (const MgtAddBaRequestHeader *reqHdr,
-                          Mac48Address originator);
-
-  /**
    * Enable or disable QoS support for the device.
    *
    * \param enable whether QoS is supported
@@ -279,6 +260,12 @@
   bool GetQosSupported () const;
 
   /**
+   * Create a Frame Exchange Manager depending on the supported version
+   * of the standard.
+   */
+  void SetupFrameExchangeManager (void);
+
+  /**
    * Return whether the device supports HT.
    *
    * \return true if HT is supported, false otherwise
@@ -394,6 +381,8 @@
    */
   void SetBkBlockAckInactivityTimeout (uint16_t timeout);
 
+  TypeOfStation m_typeOfStation;                        //!< the type of station
+
   /**
    * This Boolean is set \c true iff this WifiMac is to model
    * 802.11e/WMM style Quality of Service. It is exposed through the
@@ -419,10 +408,8 @@
    */
   bool m_dsssSupported;
 
-  /// Enable aggregation function
-  void EnableAggregation (void);
-  /// Disable aggregation function
-  void DisableAggregation (void);
+  Mac48Address m_address;   ///< MAC address of this station
+  Mac48Address m_bssid;     ///< the BSSID
 
   uint16_t m_voMaxAmsduSize; ///< maximum A-MSDU size for AC_VO (in bytes)
   uint16_t m_viMaxAmsduSize; ///< maximum A-MSDU size for AC_VI (in bytes)
@@ -437,7 +424,89 @@
   TracedCallback<const WifiMacHeader &> m_txOkCallback; ///< transmit OK callback
   TracedCallback<const WifiMacHeader &> m_txErrCallback; ///< transmit error callback
 
+  /// TracedCallback for acked/nacked MPDUs typedef
+  typedef TracedCallback<Ptr<const WifiMacQueueItem>> MpduTracedCallback;
+
+  MpduTracedCallback m_ackedMpduCallback;  ///< ack'ed MPDU callback
+  MpduTracedCallback m_nackedMpduCallback; ///< nack'ed MPDU callback
+
+  /**
+   * TracedCallback signature for MPDU drop events.
+   *
+   * \param reason the reason why the MPDU was dropped (\see WifiMacDropReason)
+   * \param mpdu the dropped MPDU
+   */
+  typedef void (* DroppedMpduCallback)(WifiMacDropReason reason, Ptr<const WifiMacQueueItem> mpdu);
+
+  /// TracedCallback for MPDU drop events typedef
+  typedef TracedCallback<WifiMacDropReason, Ptr<const WifiMacQueueItem>> DroppedMpduTracedCallback;
+
+  /**
+   * This trace indicates that an MPDU was dropped for the given reason.
+   */
+  DroppedMpduTracedCallback m_droppedMpduCallback;
+
+  /**
+   * TracedCallback signature for MPDU response timeout events.
+   *
+   * \param reason the reason why the timer was started
+   * \param mpdu the MPDU whose response was not received before the timeout
+   * \param txVector the TXVECTOR used to transmit the MPDU
+   */
+  typedef void (* MpduResponseTimeoutCallback)(uint8_t reason, Ptr<const WifiMacQueueItem> mpdu,
+                                               const WifiTxVector& txVector);
+
+  /// TracedCallback for MPDU response timeout events typedef
+  typedef TracedCallback<uint8_t, Ptr<const WifiMacQueueItem>, const WifiTxVector&> MpduResponseTimeoutTracedCallback;
+
+  /**
+   * MPDU response timeout traced callback.
+   * This trace source is fed by a WifiTxTimer object.
+   */
+  MpduResponseTimeoutTracedCallback m_mpduResponseTimeoutCallback;
+
+  /**
+   * TracedCallback signature for PSDU response timeout events.
+   *
+   * \param reason the reason why the timer was started
+   * \param psdu the PSDU whose response was not received before the timeout
+   * \param txVector the TXVECTOR used to transmit the PSDU
+   */
+  typedef void (* PsduResponseTimeoutCallback)(uint8_t reason, Ptr<const WifiPsdu> psdu,
+                                               const WifiTxVector& txVector);
+
+  /// TracedCallback for PSDU response timeout events typedef
+  typedef TracedCallback<uint8_t, Ptr<const WifiPsdu>, const WifiTxVector&> PsduResponseTimeoutTracedCallback;
+
+  /**
+   * PSDU response timeout traced callback.
+   * This trace source is fed by a WifiTxTimer object.
+   */
+  PsduResponseTimeoutTracedCallback m_psduResponseTimeoutCallback;
+
+  /**
+   * TracedCallback signature for PSDU map response timeout events.
+   *
+   * \param reason the reason why the timer was started
+   * \param psduMap the PSDU map for which not all responses were received before the timeout
+   * \param missingStations the MAC addresses of the stations that did not respond
+   * \param nTotalStations the total number of stations that had to respond
+   */
+  typedef void (* PsduMapResponseTimeoutCallback)(uint8_t reason, WifiPsduMap* psduMap,
+                                                  const std::set<Mac48Address>* missingStations,
+                                                  std::size_t nTotalStations);
+
+  /// TracedCallback for PSDU map response timeout events typedef
+  typedef TracedCallback<uint8_t, WifiPsduMap*, const std::set<Mac48Address>*, std::size_t> PsduMapResponseTimeoutTracedCallback;
+
+  /**
+   * PSDU map response timeout traced callback.
+   * This trace source is fed by a WifiTxTimer object.
+   */
+  PsduMapResponseTimeoutTracedCallback m_psduMapResponseTimeoutCallback;
+
   bool m_shortSlotTimeSupported; ///< flag whether short slot time is supported
+  bool m_ctsToSelfSupported;     ///< flag indicating whether CTS-To-Self is supported
 };
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/simple-frame-capture-model.h ns-3.34/src/wifi/model/simple-frame-capture-model.h
--- ns-3.33/src/wifi/model/simple-frame-capture-model.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/simple-frame-capture-model.h	2021-07-14 10:31:07.000000000 -0700
@@ -69,7 +69,7 @@
    * \return true if the reception should be switched to a new incoming frame,
    *         false otherwise
    */
-  bool CaptureNewFrame (Ptr<Event> currentEvent, Ptr<Event> newEvent) const;
+  bool CaptureNewFrame (Ptr<Event> currentEvent, Ptr<Event> newEvent) const override;
 
 
 private:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/snr-tag.h ns-3.34/src/wifi/model/snr-tag.h
--- ns-3.33/src/wifi/model/snr-tag.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/snr-tag.h	2021-07-14 10:31:07.000000000 -0700
@@ -39,17 +39,17 @@
    * \return the object TypeId
    */
   static TypeId GetTypeId (void);
-  TypeId GetInstanceTypeId (void) const;
 
   /**
    * Create a SnrTag with the default SNR 0
    */
   SnrTag ();
 
-  uint32_t GetSerializedSize (void) const;
-  void Serialize (TagBuffer i) const;
-  void Deserialize (TagBuffer i);
-  void Print (std::ostream &os) const;
+  TypeId GetInstanceTypeId (void) const override;
+  uint32_t GetSerializedSize (void) const override;
+  void Serialize (TagBuffer i) const override;
+  void Deserialize (TagBuffer i) override;
+  void Print (std::ostream &os) const override;
 
   /**
    * Set the SNR to the given value.
